#include <algorithm>
#include <iostream>
#include "utf8.h"

int main () {
  std::string within_text("ℇ¥ǢǾ¥ǽƱ");
  std::cout << "Within String " << within_text << std::endl;
  utf8::iterator<std::string::const_iterator> within_utf_iter(
      within_text.begin(), within_text.begin(), within_text.end());
  utf8::iterator<std::string::const_iterator> within_utf_end_iter(
      within_text.end(), within_text.begin(), within_text.end());

  std::string find_text("¥");
  std::cout << "Find String " << find_text << std::endl;
  utf8::iterator<std::string::const_iterator> find_utf_iter(
      find_text.begin(), find_text.begin(), find_text.end());
  utf8::iterator<std::string::const_iterator> find_utf_end_iter(
      find_text.end(), find_text.begin(), find_text.end());

  utf8::iterator<std::string::const_iterator> result_utf_iter =
      std::search(within_utf_iter, within_utf_end_iter, find_utf_iter,
      find_utf_end_iter);

  if (result_utf_iter == within_utf_end_iter) {
    std::cout << "Error occurred" << std::endl;
    return -1;
  }
  // Add one to convert to one based index
  int32_t pos = utf8::distance(within_utf_iter.base(),
      result_utf_iter.base()) + 1;
  std::cout << "String found at position " << pos << std::endl;
  return pos;
}